#ifndef CONNECTION_LOGGER_H
#define CONNECTION_LOGGER_H

/*!
  \file
  \brief ʐM̋L^

  \author Satofumi KAMIMURA

  $Id$
*/

#include "ConnectionInterface.h"
#include <SDL_net.h>
#include <memory>

class SocketSet;


class ConnectionLogger : public ConnectionInterface {
  ConnectionLogger(void);
  ConnectionLogger(const ConnectionLogger& rhs);
  ConnectionLogger& operator = (const ConnectionLogger& rhs);

  struct pImpl;
  const std::auto_ptr<pImpl> pimpl;

public:
  ConnectionLogger(ConnectionInterface* com);
  ~ConnectionLogger(void);

  const char* what(void);
  int connect(const char* host, long port);
  void disconnect(void);
  bool isConnected(void);
  int changeBaudrate(long baudrate);
  int send(const char* data, int size);
  int recv(char* data, int size, int timeout);
  int size(void);
  void clear(void);
  void skip(int timeout);

  void setLogfileName(const char* logfileName);
};

#endif /* !CONNECTION_LOGGER_H */
